﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=9.801
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public SQL As JdbcSQL
	Private Driver As String="net.sourceforge.jtds.jdbc.Driver"
	Private Url As String="jdbc:jtds:sqlserver://"
	Private Usuario As String="usuario"
	Private Password As String="clave"
	Public ListaValores As List
End Sub

Sub Service_Create
	'This is the program entry point.
	'This is a good place to load resources that are not specific to a single activity.
	DisableStrictMode
End Sub

Sub Service_Start (StartingIntent As Intent)
	ListaValores.Initialize
	Service.StopAutomaticForeground 'Starter service can start in the foreground state in some edge cases.
End Sub

Sub DisableStrictMode
	Dim jo As JavaObject
	jo.InitializeStatic("android.os.Build.VERSION")
	If jo.GetField("SDK_INT") > 9 Then
		Dim policy As JavaObject
		policy = policy.InitializeNewInstance("android.os.StrictMode.ThreadPolicy.Builder", Null)
		policy = policy.RunMethodJO("permitAll", Null).RunMethodJO("build", Null)
		Dim sm As JavaObject
		sm.InitializeStatic("android.os.StrictMode").RunMethod("setThreadPolicy", Array(policy))
	End If
End Sub

Sub Service_TaskRemoved
	'This event will be raised when the user removes the app from the recent apps list.
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub

Sub ConexionSQL As ResumableSub
	SQL.InitializeAsync("SQL", Driver, Url & Main.IPServer & "/" & Main.DBase, Usuario, Password)
	Wait For SQL_Ready (Success As Boolean)
	If Success = False Then
		Log("Error de Conexión")
	End If
	Return Success
End Sub

Sub CloseConexionSQL
	SQL.Close
End Sub

Sub LeerValoresSQL
	If File.Exists(File.DirInternal,"Valores.txt") Then
		ListaValores = File.ReadList(File.DirInternal, "Valores.txt")
		Main.IPServer=ListaValores.Get(0)
		Main.DBase=ListaValores.Get(1)
	End If
End Sub

Sub EscribirValoresSQL
	ListaValores.AddAll(Array As String(Main.IPServer,Main.DBase))
	If File.Exists(File.DirInternal,"Valores.txt") Then
		File.WriteList(File.DirInternal,"Valores.txt",ListaValores)
	Else
		File.WriteList(File.DirInternal,"Valores.txt",ListaValores)
	End If
End Sub

Sub InfoArticulo(Codigo As String) As ResumableSub
	Dim Nombre As String
	Wait For (ConexionSQL) Complete (Result As Boolean)
	If Result Then
		Dim SenderFilter As Object = SQL.ExecQueryAsync("SQL", "Select * from Articulos Where Codigo_Barras='" & Codigo & "'", Null)
		Wait For (SenderFilter) SQL_QueryComplete (Success As Boolean, Crsr As JdbcResultSet)'
		If Success Then
			Do While Crsr.NextRow
				Nombre=Crsr.GetString("Descripcion")
				Main.Precio=Crsr.GetInt("Preciocontado")
			Loop
		Else
			Nombre=""
		End If
	End If
	CloseConexionSQL
	Return Nombre
End Sub